/*
 * Grouper.java
 *
 * Created on July 30, 2007, 7:20 PM
 */

package org.yourorghere.compoundedit;

import java.awt.Toolkit;
import javax.swing.JEditorPane;
import javax.swing.event.UndoableEditListener;
import javax.swing.text.AbstractDocument;
import javax.swing.text.JTextComponent;
import javax.swing.undo.CompoundEdit;
import org.netbeans.api.editor.EditorRegistry;
import org.netbeans.modules.editor.NbEditorUtilities;
import org.openide.awt.StatusDisplayer;
import org.openide.awt.UndoRedo;
import org.openide.windows.TopComponent;
import org.openide.windows.WindowManager;

/**
 *
 * @author  erra
 */
public class Grouper extends javax.swing.JDialog {
    
    /** Creates new form Grouper */
    private Grouper(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
    }

    private static Grouper grouper;
    public static void activate() {
        if(grouper == null) {
            grouper = new Grouper(WindowManager.getDefault().getMainWindow(),
                                  false);
        }
        grouper.setVisible(true);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {

        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();

        jButton1.setText(org.openide.util.NbBundle.getMessage(Grouper.class, "Grouper.jButton1.text")); // NOI18N
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jButton2.setText(org.openide.util.NbBundle.getMessage(Grouper.class, "Grouper.jButton2.text")); // NOI18N
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jLabel1.setText(org.openide.util.NbBundle.getMessage(Grouper.class, "Grouper.jLabel1.text")); // NOI18N

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(jButton1)
                .add(18, 18, 18)
                .add(jLabel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 114, Short.MAX_VALUE)
                .add(18, 18, 18)
                .add(jButton2)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap(266, Short.MAX_VALUE)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jButton1)
                    .add(jButton2)
                    .add(jLabel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        layout.linkSize(new java.awt.Component[] {jButton1, jButton2}, org.jdesktop.layout.GroupLayout.VERTICAL);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private CompoundEdit ce;
    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        // TODO add your handling code here:
        // begin undo group
        if(ce != null) {
            error("Undo Group already active");
            return;
        }
        JTextComponent jtc = EditorRegistry.lastFocusedComponent();
        if(jtc == null) {
            error("No editor component");
            return;
        }
        JEditorPane jep = null;
        if(!(jtc instanceof JEditorPane)) {
            error("Not a JEditorPane");
            return;
        }
        jep = (JEditorPane) jtc;
        UndoRedo.Manager man = getUndoRedo(jep);
        if(man == null) {
            error("No UndoRedo manager");
            return;
        } 
        setState(getName(jep));
        ce = new CompoundEdit();
        man.addEdit(ce);
    }//GEN-LAST:event_jButton1ActionPerformed

    private UndoRedo.Manager getUndoRedo(JEditorPane jep) {
        UndoRedo.Manager undoRedo = null;
        TopComponent tc = NbEditorUtilities.getTopComponent(jep);
        if(tc != null)
            undoRedo = (UndoRedo.Manager)tc.getUndoRedo();
        return undoRedo;
    }

    private String getName(JEditorPane jep) {
        TopComponent tc = NbEditorUtilities.getTopComponent(jep);
        return tc.getDisplayName();
    }

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        // TODO add your handling code here:
        if(ce == null) {//GEN-LAST:event_jButton2ActionPerformed
            error("No Undo Group active");
            return;
        }
        setState("");
        ce.end();
        ce = null;
    }
    
    private void setState(String msg) {
        jLabel1.setText(msg);
    }
    
    private void error(String msg) {
        StatusDisplayer.getDefault().setStatusText(msg);
        Toolkit.getDefaultToolkit().beep();
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                Grouper dialog = new Grouper(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JLabel jLabel1;
    // End of variables declaration//GEN-END:variables
    
}
